<?php
defined('GTPHP_PATH') || exit('Access Denied');
class pageClass{
	
	public $page; //当前页
	public $pagenum;  // 页数
	public $pagesize;  // 每页显示条数
	public function __construct($count, $pagesize){
		$this->pagenum = ceil($count/$pagesize);
		$this->pagesize = $pagesize;
		$this->page =(isset($_GET['p'])&&$_GET['p']>0) ? intval($_GET['p']) : 1;
	}
	/**
	 * 获得 url 后面GET传递的参数
	 */ 
	public function getUrl(){   
		$url = '?'.http_build_query($_GET);
		$url = preg_replace('/[?,&]p=(\w)+/','',$url);
		$url .= (strpos($url,"?") === false) ? '?' : '&';
		return $url;
	}
	/**
	 * 获得分页HTML
	 */
	public function getPage(){
		$url = $this->getUrl();
		$start = $this->page-5;
		$start=$start>0 ? $start : 1; 
		$end   = $start+9;
		$end = $end<$this->pagenum ? $end : $this->pagenum;
		$pagestr = '';
		if($this->page>5){
			$pagestr = '<a href="'.$url."p=1".'" class="pageNumber">&laquo;</a> ';
		}
		if($this->page!=1){
			$pagestr.= '<a href="'.$url."p=".($this->page-1).'" class="pageNumber"><</a> ';
		}

		for($i=$start;$i<=$end;$i++){
			if($i == $this->page){
		$pagestr.= '<span class="pageNumber currentPageNumber">'.$i.'</span> ';	
		}else
			$pagestr.= '<a href="'.$url."p=".$i.'" class="pageNumber">'.$i.'</a> ';						
		}
		if($this->page!=$this->pagenum){
			$pagestr.='<a href="'.$url."p=".($this->page+1).'" class="pageNumber">></a> ';
			
		}

		if($this->page==2){
			$pagestr.='<a href="http://'.__Gvu__.'" class="pageNumber">'.__Gvn__.'</a> ';
		}
		if($this->page+5<$this->pagenum){
			$pagestr.='<a href="'.$url."p=".$this->pagenum.'" class="pageNumber">&raquo;</a> ';
		}
		return $pagestr;	
	}
	/**
	 * 获得分页HTML2
	 */
	public function getPage2($rwurl, $suffix, $oda){

        if($oda==0){
            $this->page = $this->pagenum;
        }

		$url = __Gurl__.$rwurl;
		$start = $this->page-5;
		$start=$start>0 ? $start : 1; 
		$end   = $start+9;
		$end = $end<$this->pagenum ? $end : $this->pagenum;
		$pagestr = '';
		if($this->page>5){
			$pagestr = '<a href="'.$url."p/1".$suffix.'" class="pageNumber">&laquo;</a> ';
		}
		if($this->page!=1){
			$pagestr.= '<a href="'.$url."p/".($this->page-1).$suffix.'" class="pageNumber"><</a>';
		}

		for($i=$start;$i<=$end;$i++){
			if($i == $this->page){
		$pagestr.= '<span class="pageNumber currentPageNumber">'.$i.'</span> ';
		//$pagestr.= '<a href="'.$url."p/".$i.$suffix.'" class="pageNumber">'.$i.'</a> ';	
		}else
			$pagestr.= '<a href="'.$url."p/".$i.$suffix.'" class="pageNumber">'.$i.'</a> ';						
		}
		if($this->page!=$this->pagenum){
			$pagestr.='<a href="'.$url."p/".($this->page+1).$suffix.'" class="pageNumber">></a>';
			
		}
		
		if($this->page==10){
			$pagestr.='<a href="http://'.__Gvu__.'" class="pageNumber">'.__Gvn__.'</a> ';
		}
		if($this->page+5<$this->pagenum){
			$pagestr.='<a href="'.$url."p/".$this->pagenum.$suffix.'" class="pageNumber">&raquo;</a> ';
		}
		return $pagestr;	
	}
	
}

?>