<?php
defined('GTPHP_PATH') || exit('Access Denied');
class mobileModel{
	//
	function index($sqlfirst,$pagesize){
		$myconfig = new myconfig();
		$mydbconfig=$myconfig->mydbconfig();
		$database = new medooClass($mydbconfig);
		$datas = $database->select("g_article", array("g_id","g_cid","g_title"
		), array(
    "ORDER" => "g_id DESC",
    "LIMIT" => array($sqlfirst,$pagesize)
    ));
		return $datas;
	}
	//
	function adda($g_cid,$g_title,$g_tag,$g_des,$g_content,$g_author,$g_imgurl,$g_time,$g_top,$g_rec,$g_click){
		$myconfig = new myconfig();
		$mydbconfig=$myconfig->mydbconfig();
		$database = new medooClass($mydbconfig);
		$last_id = $database->insert("g_article", array(
		"g_cid" => $g_cid,
		"g_title" => $g_title,
		"g_tag" => $g_tag,
		"g_des" => $g_des,
		"g_content" => $g_content,
		"g_author" => $g_author,
		"g_imgurl" => $g_imgurl,
		"g_time" => $g_time,
		"g_top" => $g_top,
		"g_rec" => $g_rec,
		"g_click" => $g_click
		));
		return $last_id;
  }
  //
  function edita($g_cid,$g_title,$g_tag,$g_des,$g_content,$g_author,$g_imgurl,$g_time,$g_top,$g_rec,$g_click){
		$myconfig = new myconfig();
		$mydbconfig=$myconfig->mydbconfig();
		$database = new medooClass($mydbconfig);
		$dataok=$database->update("g_article", array(
		"g_cid" => $g_cid,
		"g_title" => $g_title,
		"g_tag" => $g_tag,
		"g_des" => $g_des,
		"g_content" => $g_content,
		"g_author" => $g_author,
		"g_imgurl" => $g_imgurl,
		"g_time" => $g_time,
		"g_top" => $g_top,
		"g_rec" => $g_rec,
		"g_click" => $g_click
		), array("g_id" => $g_id)
		);
		return $dataok;
   }
  //
  function dela($g_id){
		$myconfig = new myconfig();
		$mydbconfig=$myconfig->mydbconfig();
		$database = new medooClass($mydbconfig);
		$dataok=$database->delete("g_article", array(
		"AND" => array(
		"g_id" => $g_id
		)));
		return $dataok;
   }
  //
  function counta(){
		$myconfig = new myconfig();
		$mydbconfig=$myconfig->mydbconfig();
		$database = new medooClass($mydbconfig);
		$count = $database->count("g_article", array());//
		return $count;
   }
	//
	function onea($g_id){
		$myconfig = new myconfig();
		$mydbconfig=$myconfig->mydbconfig();
		$database = new medooClass($mydbconfig);
		$datas = $database->get("g_article", array("g_id","g_cid","g_title","g_tag","g_des","g_content","g_author","g_imgurl","g_time","g_top","g_rec","g_click"
		), array(
		"g_id" => $g_id
    ));
		return $datas;
	}

}