<?php
defined('GTPHP_PATH') || exit('Access Denied');
class siteModel{
	//查询文章
	function article($sqlfirst,$pagesize,$oda){
		$myconfig = new myconfig();
		$mydbconfig=$myconfig->mydbconfig();
		$database = new medooClass($mydbconfig);
        if($oda==0){
                
		$datas = $database->select("g_article", array("g_id", "g_cid", "g_title", "g_tag", "g_des", "g_author", "g_imgurl", "g_time", "g_top", "g_rec", "g_click"
		), array(
    "ORDER" => "g_id DESC",
    "LIMIT" => array($sqlfirst,$pagesize)
    ));

                } else {
                    
        $datas = $database->select("g_article", array("g_id", "g_cid", "g_title", "g_tag", "g_des", "g_author", "g_imgurl", "g_time", "g_top", "g_rec", "g_click"
        ), array(
    "ORDER" => "g_id ASC",
    "LIMIT" => array($sqlfirst,$pagesize)
    ));

                }
		return $datas;
	}
	//查询文章(分类,$sqlfirst,$pagesize,排序)
	function classarticle($classid,$sqlfirst,$pagesize,$oda){
		$myconfig = new myconfig();
		$mydbconfig=$myconfig->mydbconfig();
		$database = new medooClass($mydbconfig);

        if($oda==0){
                
		$datas = $database->select("g_article", array("g_id", "g_cid", "g_title", "g_tag", "g_des", "g_author", "g_imgurl", "g_time", "g_top", "g_rec", "g_click"
		), array(
    "g_cid" => $classid,
    "ORDER" => "g_id DESC",
    "LIMIT" => array($sqlfirst,$pagesize)
    ));

                } else {

        $datas = $database->select("g_article", array("g_id", "g_cid", "g_title", "g_tag", "g_des", "g_author", "g_imgurl", "g_time", "g_top", "g_rec", "g_click"
        ), array(
    "g_cid" => $classid,
    "ORDER" => "g_id ASC",
    "LIMIT" => array($sqlfirst,$pagesize)
    ));

                }
		return $datas;
	}
    //文章调用($classid,$sqlfirst,$pagesize,0=最新/1=置顶/2=推荐)
    function optionarticle($classid,$sqlfirst,$pagesize,$aoption){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);

        if($classid!=-1){
                
                if ($aoption==1) {
                    $datas = $database->select("g_article", array("g_id", "g_cid", "g_title", "g_tag", "g_des", "g_author", "g_imgurl", "g_time", "g_top", "g_rec", "g_click"
                        ), array(
                        "AND" => array(
                        "g_cid" => $classid,
                        "g_top" => 1
                        ),
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                } elseif ($aoption==2) {
                    $datas = $database->select("g_article", array("g_id", "g_cid", "g_title", "g_tag", "g_des", "g_author", "g_imgurl", "g_time", "g_top", "g_rec", "g_click"
                        ), array( 
                        "AND" => array(
                        "g_cid" => $classid,
                        "g_rec" => 1
                        ),
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                } else {
                    $datas = $database->select("g_article", array("g_id", "g_cid", "g_title", "g_tag", "g_des", "g_author", "g_imgurl", "g_time", "g_top", "g_rec", "g_click"
                        ), array( 
                        "AND" => array(
                        "g_cid" => $classid,
                        "g_top[<>]" => 1,
                        "g_rec[<>]" => 1
                        ),
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                }

        }else{

                if ($aoption==1) {
                    $datas = $database->select("g_article", array("g_id", "g_cid", "g_title", "g_tag", "g_des", "g_author", "g_imgurl", "g_time", "g_top", "g_rec", "g_click"
                        ), array( 
                        "g_top" => 1,
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                } elseif ($aoption==2) {
                    $datas = $database->select("g_article", array("g_id", "g_cid", "g_title", "g_tag", "g_des", "g_author", "g_imgurl", "g_time", "g_top", "g_rec", "g_click"
                        ), array( 
                        "g_rec" => 1,
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                } else {
                    $datas = $database->select("g_article", array("g_id", "g_cid", "g_title", "g_tag", "g_des", "g_author", "g_imgurl", "g_time", "g_top", "g_rec", "g_click"
                        ), array(
                        "AND" => array(
        "OR" => array(
                        "g_top" => 0,
                        "g_rec" => 0
        ),
        "OR" => array(
                        "g_top" => null,
                        "g_rec" => null
        )
                        ),
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                }
                
        }
        return $datas;
    }
  //取得记录数
  function countarticle(){
		$myconfig = new myconfig();
		$mydbconfig=$myconfig->mydbconfig();
		$database = new medooClass($mydbconfig);
		$count = $database->count("g_article", array());//取得数据表的总记录数
		return $count;
   }
  //取得分类记录数
  function countclass($classid){
		$myconfig = new myconfig();
		$mydbconfig=$myconfig->mydbconfig();
		$database = new medooClass($mydbconfig);
		$count = $database->count("g_article", array(
    "g_cid" => $classid));//取得数据表的总记录数
		return $count;
   }
	//查询一条记录
	function onearticle($g_id){
		$myconfig = new myconfig();
		$mydbconfig=$myconfig->mydbconfig();
		$database = new medooClass($mydbconfig);
		$datas = $database->get("g_article", array("g_id", "g_cid", "g_title", "g_tag", "g_des", "g_content", "g_author", "g_imgurl", "g_time", "g_top", "g_rec", "g_click"
		), array(
		"g_id" => $g_id
    ));
		return $datas;
	}	
	//查询上一篇文章
	function ponearticle($g_id){
		$myconfig = new myconfig();
		$mydbconfig=$myconfig->mydbconfig();
		$database = new medooClass($mydbconfig);
		$datas = $database->get("g_article", array("g_id", "g_cid", "g_title"
		), array(
    "ORDER" => "g_id DESC",
		"g_id[<]" => $g_id
    ));
		return $datas;
	}	
	//查询下一篇文章
	function nonearticle($g_id){
		$myconfig = new myconfig();
		$mydbconfig=$myconfig->mydbconfig();
		$database = new medooClass($mydbconfig);
		$datas = $database->get("g_article", array("g_id", "g_cid", "g_title"
		), array(
		"g_id[>]" => $g_id
    ));
		return $datas;
	}	
	//搜索
	function search($key,$sqlfirst,$pagesize){
		$myconfig = new myconfig();
		$mydbconfig=$myconfig->mydbconfig();
		$database = new medooClass($mydbconfig);
		$datas = $database->select("g_article",array("g_id", "g_cid", "g_title", "g_tag", "g_des", "g_author", "g_imgurl", "g_time", "g_top", "g_rec", "g_click"),array(
		'LIKE' => array(
		'g_title' => $key
	),
    "LIMIT" => array($sqlfirst,$pagesize)
));
		
		return $datas;
	}
   
  //取得搜索记录数
  function counts($key){
		$myconfig = new myconfig();
		$mydbconfig=$myconfig->mydbconfig();
		$database = new medooClass($mydbconfig);
		$count = $database->count("g_article",array(
		'LIKE' => array(
		'g_title' => $key
	)));//取得数据表的总记录数
		return $count;
   }	
   
    //搜索tag
    function searchtag($tag,$sqlfirst,$pagesize){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $datas = $database->select("g_article",array("g_id", "g_cid", "g_title", "g_tag", "g_des", "g_author", "g_imgurl", "g_time", "g_top", "g_rec", "g_click"),array(
        'LIKE' => array(
        'g_tag' => $tag
    ),
    "ORDER" => "g_id DESC",
    "LIMIT" => array($sqlfirst,$pagesize)
));
        
        return $datas;
    }
   
  //取得搜索tag记录数
  function countstag($tag){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $count = $database->count("g_article",array(
        'LIKE' => array(
        'g_title' => $tag
    )));//取得数据表的总记录数
        return $count;
   }    
   
    //搜索日期
    function searchdate($sdate,$edate,$sqlfirst,$pagesize){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $datas = $database->select("g_article",array("g_id", "g_cid", "g_title", "g_tag", "g_des", "g_author", "g_imgurl", "g_time", "g_top", "g_rec", "g_click"),array(
        array(
        "g_time[<>]" => array($sdate,$edate)
    ),
    "ORDER" => "g_id DESC",
    "LIMIT" => array($sqlfirst,$pagesize)
));
        
        return $datas;
    }
   
  //取得搜索tag日期记录数
  function countsdate($sdate,$edate){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $count = $database->count("g_article",array(
        array(
        "g_time[<>]" => array($sdate,$edate)
    )));//取得数据表的总记录数
        return $count;
   }    
      
  //查询导航
    function sitenav(){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $datas = $database->select("g_nav", "*"
        , array(
    "ORDER" => "g_order DESC"
    ));
        return $datas;
    }
  //查询分类
	function siteclass(){
		$myconfig = new myconfig();
		$mydbconfig=$myconfig->mydbconfig();
		$database = new medooClass($mydbconfig);
		$datas = $database->select("g_class", "*"
		, array(
    "ORDER" => "g_cid ASC"
    ));
		return $datas;
	}
	//查询配置
	function config(){
		$myconfig = new myconfig();
		$mydbconfig=$myconfig->mydbconfig();
		$database = new medooClass($mydbconfig);
		$datas = $database->select("g_config", "*"
		, array(
    "ORDER" => "g_id ASC"
    ));
		return $datas;
	}
    //查询自定义信息
    function diyinfo(){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $datas = $database->select("g_info", "*"
        , array(
    "ORDER" => "g_id ASC"
    ));
        return $datas;
    }
    //查询单页文章
    function onepages($g_id){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $datas = $database->get("g_pages", array("g_id", "g_title", "g_key", "g_des", "g_content", "g_t", "g_oname", "g_click"
        ), array(
        "g_id" => $g_id
    ));
        return $datas;
    }   
  //查询单页列表
    function sitepages(){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $datas = $database->select("g_pages",  array("g_id", "g_title", "g_t", "g_oname", "g_click"
        ), array(
    "ORDER" => "g_id ASC"
    ));
        return $datas;
    }
//图片

    //查询图片
    function photo($sqlfirst,$pagesize,$oda){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        if($oda==0){
        $datas = $database->select("g_pic", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_time", "g_top", "g_rec", "g_click"
        ), array(
    "ORDER" => "g_id DESC",
    "LIMIT" => array($sqlfirst,$pagesize)
    ));

                } else {
        $datas = $database->select("g_pic", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_time", "g_top", "g_rec", "g_click"
        ), array(
    "ORDER" => "g_id ASC",
    "LIMIT" => array($sqlfirst,$pagesize)
    ));

                }
        return $datas;
    }
    //查询图片
    function classphoto($classid,$sqlfirst,$pagesize,$oda){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);

        if($oda==0){
                

        $datas = $database->select("g_pic", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_time", "g_top", "g_rec", "g_click"
        ), array(
    "g_cid" => $classid,
    "ORDER" => "g_id DESC",
    "LIMIT" => array($sqlfirst,$pagesize)
    ));

                } else {

        $datas = $database->select("g_pic", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_time", "g_top", "g_rec", "g_click"
        ), array(
    "g_cid" => $classid,
    "ORDER" => "g_id ASC",
    "LIMIT" => array($sqlfirst,$pagesize)
    ));

                }
        return $datas;
    }

    //
    function optionphoto($classid,$sqlfirst,$pagesize,$aoption){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);

        if($classid!=-1){
                
                if ($aoption==1) {
                    $datas = $database->select("g_pic", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_time", "g_top", "g_rec", "g_click"
        ), array(
                        "AND" => array(
                        "g_cid" => $classid,
                        "g_top" => 1
                        ),
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                } elseif ($aoption==2) {
                    $datas = $database->select("g_pic", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_time", "g_top", "g_rec", "g_click"
        ), array( 
                        "AND" => array(
                        "g_cid" => $classid,
                        "g_rec" => 1
                        ),
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                } else {
                    $datas = $database->select("g_pic", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_time", "g_top", "g_rec", "g_click"
        ), array( 
                        "AND" => array(
                        "g_cid" => $classid,
                        "g_top[<>]" => 1,
                        "g_rec[<>]" => 1
                        ),
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                }

        }else{

                if ($aoption==1) {
                    $datas = $database->select("g_pic", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_time", "g_top", "g_rec", "g_click"
        ), array( 
                        "g_top" => 1,
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                } elseif ($aoption==2) {
                    $datas = $database->select("g_pic", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_time", "g_top", "g_rec", "g_click"
        ), array( 
                        "g_rec" => 1,
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                } else {
                    $datas = $database->select("g_pic", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_time", "g_top", "g_rec", "g_click"
        ), array(
                        "AND" => array(
        "OR" => array(
                        "g_top" => 0,
                        "g_rec" => 0
        ),
        "OR" => array(
                        "g_top" => null,
                        "g_rec" => null
        )
                        ),
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                }
                
        }
        return $datas;
    }

    //查询一条记录
    function onephoto($g_id){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $datas = $database->get("g_pic", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_time", "g_top", "g_rec", "g_click"
        ), array(
        "g_id" => $g_id
    ));
        return $datas;
    }   
    //相片
    function photos($g_id){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $datas = $database->select("g_child_pics", array("g_pid", "g_id", "g_pname", "g_photo"
        ), array(
        "g_id" => $g_id
    ));
        return $datas;
    }   
  //取得图片记录数
  function countphoto(){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $count = $database->count("g_pic", array());//取得数据表的总记录数
        return $count;
   }
  //取得图片分类记录数
  function countclassphoto($classid){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $count = $database->count("g_pic", array(
    "g_cid" => $classid));//取得数据表的总记录数
        return $count;
   }
  //查询图片分类
    function sitephotoclass(){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $datas = $database->select("g_pclass", "*"
        , array(
    "ORDER" => "g_cid ASC"
    ));
        return $datas;
    }

//视频

    //查询视频
    function video($sqlfirst,$pagesize,$oda){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        if($oda==0){
        $datas = $database->select("g_video", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_video_html", "g_video_url", "g_video", "g_click", "g_time", "g_top", "g_rec", "g_click"
        ), array(
    "ORDER" => "g_id DESC",
    "LIMIT" => array($sqlfirst,$pagesize)
    ));

                } else {
        $datas = $database->select("g_video", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_video_html", "g_video_url", "g_video", "g_click", "g_time", "g_top", "g_rec", "g_click"
        ), array(
    "ORDER" => "g_id ASC",
    "LIMIT" => array($sqlfirst,$pagesize)
    ));

                }
        return $datas;
    }
    //查询视频
    function classvideo($classid,$sqlfirst,$pagesize,$oda){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);

        if($oda==0){
        $datas = $database->select("g_video", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_video_html", "g_video_url", "g_video", "g_click", "g_time", "g_top", "g_rec", "g_click"
        ), array(
    "g_cid" => $classid,
    "ORDER" => "g_id DESC",
    "LIMIT" => array($sqlfirst,$pagesize)
    ));

                } else {
        $datas = $database->select("g_video", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_video_html", "g_video_url", "g_video", "g_click", "g_time", "g_top", "g_rec", "g_click"
        ), array(
    "g_cid" => $classid,
    "ORDER" => "g_id ASC",
    "LIMIT" => array($sqlfirst,$pagesize)
    ));

                }
        return $datas;
    }

    //视频调用
    function optionvideo($classid,$sqlfirst,$pagesize,$aoption){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);

        if($classid!=-1){
                
                if ($aoption==1) {
                    $datas = $database->select("g_video", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_video_html", "g_video_url", "g_video", "g_click", "g_time", "g_top", "g_rec", "g_click"
        ), array(
                        "AND" => array(
                        "g_cid" => $classid,
                        "g_top" => 1
                        ),
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                } elseif ($aoption==2) {
                    $datas = $database->select("g_video", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_video_html", "g_video_url", "g_video", "g_click", "g_time", "g_top", "g_rec", "g_click"
        ), array( 
                        "AND" => array(
                        "g_cid" => $classid,
                        "g_rec" => 1
                        ),
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                } else {
                    $datas = $database->select("g_video", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_video_html", "g_video_url", "g_video", "g_click", "g_time", "g_top", "g_rec", "g_click"
        ), array( 
                        "AND" => array(
                        "g_cid" => $classid,
                        "g_top[<>]" => 1,
                        "g_rec[<>]" => 1
                        ),
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                }

        }else{

                if ($aoption==1) {
                    $datas = $database->select("g_video", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_video_html", "g_video_url", "g_video", "g_click", "g_time", "g_top", "g_rec", "g_click"
        ), array( 
                        "g_top" => 1,
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                } elseif ($aoption==2) {
                    $datas = $database->select("g_video", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_video_html", "g_video_url", "g_video", "g_click", "g_time", "g_top", "g_rec", "g_click"
        ), array( 
                        "g_rec" => 1,
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                } else {
                    $datas = $database->select("g_video", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_video_html", "g_video_url", "g_video", "g_click", "g_time", "g_top", "g_rec", "g_click"
        ), array(
                        "AND" => array(
        "OR" => array(
                        "g_top" => 0,
                        "g_rec" => 0
        ),
        "OR" => array(
                        "g_top" => null,
                        "g_rec" => null
        )
                        ),
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                }
                
        }
        return $datas;
    }
    //查询一条视频记录
    function onevideo($g_id){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $datas = $database->get("g_video", array("g_id", "g_cid", "g_title", "g_key", "g_des", "g_pic", "g_video_html", "g_video_url", "g_video", "g_click", "g_time", "g_top", "g_rec", "g_click"
        ), array(
        "g_id" => $g_id
    ));
        return $datas;
    }   
  //取得视频记录数
  function countvideo(){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $count = $database->count("g_video", array());//取得数据表的总记录数
        return $count;
   }
  //取得视频分类记录数
  function countclassvideo($classid){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $count = $database->count("g_video", array(
    "g_cid" => $classid));//取得数据表的总记录数
        return $count;
   }
  //查询视频分类
    function sitevideoclass(){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $datas = $database->select("g_vclass", "*"
        , array(
    "ORDER" => "g_cid ASC"
    ));
        return $datas;
    }

//下载

    //查询下载
    function down($sqlfirst,$pagesize,$oda){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        if($oda==0){
        $datas = $database->select("g_down", "*", array(
    "ORDER" => "g_id DESC",
    "LIMIT" => array($sqlfirst,$pagesize)
    ));

                } else {
        $datas = $database->select("g_down", "*", array(
    "ORDER" => "g_id ASC",
    "LIMIT" => array($sqlfirst,$pagesize)
    ));

                }
        return $datas;
    }
    //查询下载
    function classdown($classid,$sqlfirst,$pagesize,$oda){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);

        if($oda==0){
        $datas = $database->select("g_down", "*", array(
    "g_cid" => $classid,
    "ORDER" => "g_id DESC",
    "LIMIT" => array($sqlfirst,$pagesize)
    ));

                } else {
        $datas = $database->select("g_down", "*", array(
    "g_cid" => $classid,
    "ORDER" => "g_id ASC",
    "LIMIT" => array($sqlfirst,$pagesize)
    ));

                }
        return $datas;
    }
    //下载调用
    function optiondown($classid,$sqlfirst,$pagesize,$aoption){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);

        if($classid!=-1){
                
                if ($aoption==1) {
                    $datas = $database->select("g_down", "*", array(
                        "AND" => array(
                        "g_cid" => $classid,
                        "g_top" => 1
                        ),
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                } elseif ($aoption==2) {
                    $datas = $database->select("g_down", "*", array( 
                        "AND" => array(
                        "g_cid" => $classid,
                        "g_rec" => 1
                        ),
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                } else {
                    $datas = $database->select("g_down", "*", array( 
                        "AND" => array(
                        "g_cid" => $classid,
                        "g_top[<>]" => 1,
                        "g_rec[<>]" => 1
                        ),
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                }

        }else{

                if ($aoption==1) {
                    $datas = $database->select("g_down", "*", array( 
                        "g_top" => 1,
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                } elseif ($aoption==2) {
                    $datas = $database->select("g_down", "*", array( 
                        "g_rec" => 1,
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                } else {
                    $datas = $database->select("g_down", "*", array(
                        "AND" => array(
        "OR" => array(
                        "g_top" => 0,
                        "g_rec" => 0
        ),
        "OR" => array(
                        "g_top" => null,
                        "g_rec" => null
        )
                        ),
                        "ORDER" => "g_id DESC",
                        "LIMIT" => array($sqlfirst,$pagesize)
                        ));
                }
                
        }
        return $datas;
    }
    
    //查询一条下载记录
    function onedown($g_id){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $datas = $database->get("g_down", "*", array(
        "g_id" => $g_id
    ));
        return $datas;
    }   
    //下载
    function downs($g_id){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $datas = $database->select("g_child_downs", array("g_pid", "g_id", "g_dname", "g_durl"
        ), array(
        "g_id" => $g_id
    ));
        return $datas;
    }   
  //取得下载记录数
  function countdown(){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $count = $database->count("g_down", array());//取得数据表的总记录数
        return $count;
   }
  //取得下载分类记录数
  function countclassdown($classid){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $count = $database->count("g_down", array(
    "g_cid" => $classid));//取得数据表的总记录数
        return $count;
   }
  //查询下载分类
    function sitedownclass(){
        $myconfig = new myconfig();
        $mydbconfig=$myconfig->mydbconfig();
        $database = new medooClass($mydbconfig);
        $datas = $database->select("g_dclass", "*"
        , array(
    "ORDER" => "g_cid ASC"
    ));
        return $datas;
    }
}