<?php defined('GTPHP_PATH') || exit('Access Denied');?><?php include(__View__.'admin_header.php');?> 
<div id="documenter_content">
    <section id="methods">

<style type="text/css">
.lm_form input[type="text"]{
width:682px;
} 
.lm_g_content{
width:680px; height: 200px;
} 
.lm_g_des{
width:680px; height:60px;
} 
</style>
      <h3 class="pageTitle">文章管理</h3><hr/><div>
                        <?php

try {
  $dbh = new PDO("mysql:host=".$datas['server'].";port=".$datas['port'].";dbname=".$datas['database_name'], $datas['username'], $datas['password']);
}
catch(PDOException $e) {
    die('pdo connection error: ' . $e->getMessage());
}
$lm = new mofoClass($dbh); 
$lm->table = 'g_article';
// 主键
$lm->identity_name = 'g_id';
$lm->grid_default_order_by = 'g_id desc';

// optional, define editable input controls on the grid
$lm->grid_input_control = array('g_top' => '--checkbox','g_rec' => '--checkbox');
// optional, query for grid(). if the last column selected is the primary key identity, then the [edit] and [delete] links are displayed
$lm->grid_sql = "select m.g_id, c.g_name, m.g_title, m.g_top, m.g_rec, g_id from g_article m left join g_class c on m.g_cid = c.g_cid order by m.g_id desc";

$lm->grid_output_control = array('g_title' => '--my_output_control');
function my_output_control($column_name, $value, $command, $called_from){
    $val = str_replace("g_title-","id=",$column_name);
    return "<a href='".U('index.php?c=index&a=article&'.$val)."' target='_blank'>".$value."</a>";
}

//URL路径
$lm->uri_path = 'index.php?c=article&a=index2';
$lm->grid_export_link = '';
//添加重定向回编辑表单
$lm->return_to_edit_after_insert = false;
//更新重定向回编辑表单
$lm->return_to_edit_after_update = false;
//图片路径
$lm->upload_path = $upload_path.'uploads';
//缩略图路径
$lm->thumb_path = $upload_path.'thumbs';              // optional, leave blank if you don't need thumbnails
// 友好字段名
$lm->rename = array('g_id' => 'ID','g_name'=>'分类','g_title'=>'标题','g_top'=>'置顶','g_rec'=>'推荐','g_cid'=>'分类','g_tag'=>'标签','g_des'=>'简介','g_content'=>'内容','g_author'=>'作者','g_imgurl'=>'图片','g_time'=>'时间','g_click'=>'点击');

// optional, define input controls on the form
$lm->form_input_control = array('g_cid' => 'select g_cid, g_name from g_class; --select','g_des' => '--textarea', 'g_imgurl' => '--image','g_top' => '--checkbox', 'g_rec' => '--checkbox');

$lm->form_input_control['g_author'] = '--my_user_function';
function my_user_function($column_name, $value, $command, $called_from){
if($value == ''){
  $val = htmlspecialchars($_SESSION['nickname'], ENT_QUOTES, 'UTF-8');
}else{
  $val = htmlspecialchars($value, ENT_QUOTES, 'UTF-8');
}
    return "<input type='text' name='$column_name' value='$val' size='100' />";
}

$lm->form_input_control['g_time'] = '--my_time_function';
function my_time_function($column_name, $value, $command, $called_from){
if($value == ''){
  $val = htmlspecialchars(time(), ENT_QUOTES, 'UTF-8');
}else{
  $val = htmlspecialchars($value, ENT_QUOTES, 'UTF-8');
}
    return "<input type='text' name='$column_name' value='$val' size='100' />";
}

$lm->run();
?>
  <link rel="stylesheet" href="<?php echo __Plugins__;?>kindeditor/themes/default/default.css" />
  <link rel="stylesheet" href="<?php echo __Plugins__;?>kindeditor/plugins/code/prettify.css" />
  <script charset="utf-8" src="<?php echo __Plugins__;?>kindeditor/kindeditor.js"></script>
  <script charset="utf-8" src="<?php echo __Plugins__;?>kindeditor/lang/zh_CN.js"></script>
  <script charset="utf-8" src="<?php echo __Plugins__;?>kindeditor/plugins/code/prettify.js"></script>
  <script>
    KindEditor.ready(function(K) {
      var editor = K.create('textarea[name="g_content"]', {
        cssPath : '<?php echo __Plugins__;?>kindeditor/plugins/code/prettify.css',
        uploadJson : '<?php echo __Plugins__;?>JSON/upload_json.php',
        fileManagerJson : '<?php echo __Plugins__;?>JSON/file_manager_json.php',
        allowFileManager : true,
        afterCreate : function() {
          var self = this;
          K.ctrl(document, 13, function() {
            self.sync();
            K('form[name=contactform]')[0].submit();
          });
          K.ctrl(self.edit.doc, 13, function() {
            self.sync();
            K('form[name=contactform]')[0].submit();
          });
        }
      });
      prettyPrint();
        K('#image1').click(function() {
          editor.loadPlugin('image', function() {
            editor.plugin.imageDialog({
              imageUrl : K('#url1').val(),
              clickFn : function(url, title, width, height, border, align) {
                K('a[href="\\#editpic"]').attr('href','/phpimageeditor/editimage.php?imagesrc=..'+url);
                K('#url1').val(url);
                editor.hideDialog();
              }
            });
          });
        });
    });
  </script>


    </section>
  </div>

  <?php include(__View__.'admin_footer.php');?>