<?php defined('GTPHP_PATH') || exit('Access Denied');?><?php include(__View__.'admin_header.php');?>
    <div id="documenter_content">

    <section id="methods">

      <!-- page title starts -->
      <h3 class="pageTitle">Sitemap生成与提交</h3><hr>
 
        <?php
        $time = explode(" ",microtime());
        $time = $time[1];

        // include class
        include 'Gsys/Plugins/sitemap/SitemapGenerator.php';
        // create object
        $sitemap = new SitemapGenerator("http://goodtext.org/", "../");



        // determine how many urls should be put into one file
        $sitemap->maxURLsPerSitemap = 10000;

        // sitemap file name
        $sitemap->sitemapFileName = "sitemap.xml";

        // sitemap index file name
        $sitemap->sitemapIndexFileName = "sitemap-index.xml";

        // robots file name
        $sitemap->robotsFileName = "robots.txt";

        $urls = array();
        foreach($datas as $data){
          $urls[]=array("http://goodtext.org/sys/index/index/cid/".$data["g_id"].".htm",date('c'),'daily','0.5');
        }

        // add many URLs at one time
        $sitemap->addUrls($urls);


        try {
            // create sitemap
            $sitemap->createSitemap();

            // write sitemap as file
            $sitemap->writeSitemap();

            // update robots.txt file
            $sitemap->updateRobots();

            // submit sitemaps to search engines
            $result = $sitemap->submitSitemap();
            // shows each search engine submitting status
            echo "<pre>";
            print_r($result);
            echo "</pre>";
            
        }
        catch (Exception $exc) {
            echo $exc->getTraceAsString();
        }

        echo "Memory peak usage: ".number_format(memory_get_peak_usage()/(1024*1024),2)."MB";
        $time2 = explode(" ",microtime());
        $time2 = $time2[1];
        echo "<br>Execution time: ".number_format($time2-$time)."s";


        ?><hr>程序会自动发送ping通知给有提供自动ping服务的搜索引擎。
<hr>


    </section>
    </div>
  <?php include(__View__.'admin_footer.php');?>