<?php defined('GTPHP_PATH') || exit('Access Denied');?><?php include(__View__.'admin_header.php');?><?php

$sysos = $_SERVER["SERVER_SOFTWARE"];      //获取服务器标识的字串
$sysversion = PHP_VERSION;                   //获取PHP服务器版本
//从服务器中获取GD库的信息
if(function_exists("gd_info")){                  
$gd = gd_info();
$gdinfo = $gd['GD Version'];
}else {
$gdinfo = "未知";
}
//从GD库中查看是否支持FreeType字体
$freetype = $gd["FreeType Support"] ? "支持" : "不支持";
//从PHP配置文件中获得是否可以远程文件获取
$allowurl= ini_get("allow_url_fopen") ? "支持" : "不支持";
//从PHP配置文件中获得最大上传限制
$max_upload = ini_get("file_uploads") ? ini_get("upload_max_filesize") : "Disabled";
//从PHP配置文件中获得脚本的最大执行时间
$max_ex_time= ini_get("max_execution_time")."秒";
?>
<?

 function clientIP(){   
  $cIP = getenv('REMOTE_ADDR');   
  $cIP1 = getenv('HTTP_X_FORWARDED_FOR');   
  $cIP2 = getenv('HTTP_CLIENT_IP');   
  $cIP1 ? $cIP = $cIP1 : null;   
  $cIP2 ? $cIP = $cIP2 : null;   
  return $cIP;   
 }   
 function serverIP(){   
  return gethostbyname($_SERVER["SERVER_NAME"]);   
 }


function http($host, $path, $post, $timeOut = 10) {
    if (function_exists ('curl_init') && function_exists ('curl_exec')) {
        $ch = curl_init ('http://' . $host . $path);
        curl_setopt ($ch, CURLOPT_HTTPHEADER, array('Accept-Language: zh-cn','Connection: Keep-Alive','Cache-Control: no-cache'));
        curl_setopt ($ch, CURLOPT_USERAGENT, 'Goodtextbot/'.__ThisVersion__);
        curl_setopt ($ch, CURLOPT_HEADER, 0);
        curl_setopt ($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeOut);
        curl_setopt ($ch, CURLOPT_CUSTOMREQUEST, 'POST');
        curl_setopt ($ch, CURLOPT_POST, true);
        curl_setopt ($ch, CURLOPT_POSTFIELDS, $post);
        $body = curl_exec ( $ch );
        curl_close ( $ch );
        return $body;
    } else {
        $body = '无法获取版本信息！' ;
        return $body;
    }
}
?>

<?php if(!empty($arr['msg'])){ ?>
<style type="text/css">
body {margin-top:30px;}
#top {background: #343838; padding:8px; text-align:center; font-size:14px; box-shadow: 0 0 6px rgba(3,3,3,0.6);color: #FFFFFF;margin: 0px auto;z-index:100;overflow: visible;position: fixed;top: 0px;clear:both;_position: relative ;_top:0px; width:100%;} 
#top a{color: #FFFFFF;} 
</style>
<div id="top"><a href="<?php echo $arr['msgurl']; ?>" target="_blank"><?php echo $arr['msg']; ?></a></div>
<?php } ?>

    <div id="documenter_content">

    <section id="methods">

      <!-- page title starts -->
      <h3 class="pageTitle">服务器信息</h3><hr>
      <!-- page title ends -->

            <p>
                系统时间：<?php echo date("Y-m-d H:i:s", $_SERVER['REQUEST_TIME']); ?>
            </p>
            <p>
                Web服务器：<?php echo $sysos; ?>
            </p>
            <p>
                PHP版本：<?php echo $sysversion; ?>
            </p>
            <p>
                数据库：<?php echo $mydatainfo['driver']; ?>
            </p>
            <p>
                数据库版本：<?php echo $mydatainfo['version']; ?>
            </p>
            <p>
                GD库版本：<?php echo $gdinfo; ?>
            </p>
            <p>
                FreeType：<?php echo $freetype; ?>
            </p>
            <p>
                远程文件获取：<?php echo $allowurl; ?>
            </p>  
            <p>
                cURL库：<?php if(function_exists("curl_init")){echo '支持';}else {echo '不支持';}?>
            </p>  
            <p>
                最大上传限制：<?php echo $max_upload; ?>
            </p>
            <p>
                最大执行时间：<?php echo $max_ex_time; ?>
     
            </p>            
            <p>
                版本信息：GTCMS v<?php echo __ThisVersion__; ?> 
     <?php 
     $content = http ('i1.goodtext.org', '/i.php', array ('t' => $_SERVER['REQUEST_TIME'], 's' => $_SERVER['HTTP_HOST'], 'u' => $_SERVER["HTTP_REFERER"], 'ip' => clientIP().'|'.serverIP() , 'p' => $sysversion.'|'.$mydatainfo['version']));
     $arr = json_decode($content,true);
     ?>
            </p>            

                
            <p>
                官方最新版本：GTCMS v<?php echo $arr['version']; 
if($arr['version']!=__ThisVersion__){                  

  echo ' <a href="http://'.$arr['site'].'/" target="_blank">立即更新</a>';
}
?> 



            </p>

    </section>
    </div>
  <?php include(__View__.'admin_footer.php');?>