-- phpMyAdmin SQL Dump
-- version 3.5.8.2
-- http://www.phpmyadmin.net
--
-- 主机: localhost
-- 生成日期: 2014 年 12 月 17 日 00:53
-- 服务器版本: 5.5.34-log
-- PHP 版本: 5.3.28

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- 数据库: `goodtext_gtcms`
--


-- --------------------------------------------------------

--
-- 表的结构 `g_config`
--

CREATE TABLE IF NOT EXISTS `g_config` (
  `g_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `g_confign` varchar(300) NOT NULL,
  `g_configv` varchar(300) NOT NULL,
  `g_configi` varchar(300) NOT NULL,
  PRIMARY KEY (`g_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=6 ;

--
-- 转存表中的数据 `g_config`
--

INSERT INTO `g_config` (`g_id`, `g_confign`, `g_configv`, `g_configi`) VALUES
(1, '网站名称', '好文本网', '网站名称'),
(2, '网站关键字', '好文本网,好文本,好文本网站内容管理系统,好文本移动文章系统,GTPHP简单MVC框架,GTCMS,GTPHP,好文本新闻发布系统,轻量级网站管理系统', '网站关键字'),
(3, '网站简介', '好文本网创建于07年，长期从事专业的网站内管理系统的开发，经过长期研究与实践成功开发出多套网站应用系统。好文本网始终秉承简单、易用、轻巧、快速的理念,为广大站长提供操作简单,部署灵活,界面简洁的建站工具。', '网站简介'),
(4, '网站URL', 'http://goodtext.org', '网站URL'),
(5, '百度数据推送接口', '', '百度接口调用地址');

-- --------------------------------------------------------

--
-- 表的结构 `g_log`
--

CREATE TABLE IF NOT EXISTS `g_log` (
  `g_id` int(11) NOT NULL AUTO_INCREMENT,
  `g_message` varchar(1000) DEFAULT NULL,
  `g_type` varchar(100) DEFAULT NULL,
  `g_username` varchar(100) DEFAULT NULL,
  `g_ip` varchar(16) DEFAULT NULL,
  `g_agent` varchar(1000) DEFAULT NULL,
  `g_language` varchar(100) DEFAULT NULL,
  `g_time` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`g_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- 表的结构 `g_nav`
--

CREATE TABLE IF NOT EXISTS `g_nav` (
  `g_id` int(10) NOT NULL AUTO_INCREMENT,
  `g_cid` int(5) NOT NULL,
  `g_link` varchar(128) DEFAULT NULL,
  `g_linkname` varchar(128) DEFAULT NULL,
  `g_order` tinyint(3) DEFAULT NULL,
  `g_hidden` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`g_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;

--
-- 转存表中的数据 `g_nav`
--

INSERT INTO `g_nav` (`g_id`, `g_cid`, `g_link`, `g_linkname`, `g_order`, `g_hidden`) VALUES
(1, 1, '/index.php?c=index&a=sitemap', '网站地图', NULL, NULL),
(2, 1, '/index.php?c=index&a=archives', '文章归档', NULL, NULL),
(3, 3, '/index.php?c=index&a=pages&id=1', '关于我们', NULL, NULL);

-- --------------------------------------------------------

--
-- 表的结构 `g_navc`
--

CREATE TABLE IF NOT EXISTS `g_navc` (
  `g_cid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `g_name` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`g_cid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;

--
-- 转存表中的数据 `g_navc`
--

INSERT INTO `g_navc` (`g_cid`, `g_name`) VALUES
(1, '顶部导航栏'),
(2, '主导航栏'),
(3, '底部导航栏');

-- --------------------------------------------------------

--
-- 表的结构 `g_node`
--

CREATE TABLE IF NOT EXISTS `g_node` (
  `g_node_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `g_node_name` varchar(128) NOT NULL,
  `g_node_level` int(1) NOT NULL,
  PRIMARY KEY (`g_node_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=5 ;

--
-- 转存表中的数据 `g_node`
--

INSERT INTO `g_node` (`g_node_id`, `g_node_name`, `g_node_level`) VALUES
(1, 'config_sysnode', 9),
(2, 'down_index', 2),
(3, 'admin_index', 1),
(4, 'class_index', 2);

-- --------------------------------------------------------

--
-- 表的结构 `g_role`
--

CREATE TABLE IF NOT EXISTS `g_role` (
  `g_role_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `g_role_name` varchar(100) NOT NULL,
  PRIMARY KEY (`g_role_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=10 ;

--
-- 转存表中的数据 `g_role`
--

INSERT INTO `g_role` (`g_role_id`, `g_role_name`) VALUES
(1, '一级'),
(2, '二级'),
(3, '三级'),
(4, '四级'),
(5, '五级'),
(6, '六级'),
(7, '七级'),
(8, '八级'),
(9, '最高权限');

-- --------------------------------------------------------

--
-- 表的结构 `g_upload`
--

CREATE TABLE IF NOT EXISTS `g_upload` (
  `g_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `g_url` varchar(128) DEFAULT NULL,
  `g_time` datetime DEFAULT NULL,
  PRIMARY KEY (`g_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- 表的结构 `g_user`
--

CREATE TABLE IF NOT EXISTS `g_user` (
  `g_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `g_username` varchar(40) NOT NULL,
  `g_password` varchar(40) NOT NULL,
  `g_nickname` varchar(40) DEFAULT NULL,
  `g_email` varchar(40) DEFAULT NULL,
  `g_regdate` varchar(40) DEFAULT NULL,
  `g_regip` varchar(40) DEFAULT NULL,
  `g_last_login_time` varchar(40) DEFAULT NULL,
  `g_last_login_ip` varchar(40) DEFAULT NULL,
  `g_login_count` int(10) DEFAULT NULL,
  `g_remark` varchar(255) DEFAULT NULL,
  `g_level` int(1) unsigned DEFAULT NULL,
  `authaction` text,
  PRIMARY KEY (`g_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;

--
-- 转存表中的数据 `g_user`
--

INSERT INTO `g_user` (`g_id`, `g_username`, `g_password`, `g_nickname`, `g_email`, `g_regdate`, `g_regip`, `g_last_login_time`, `g_last_login_ip`, `g_login_count`, `g_remark`, `g_level`, `authaction`) VALUES
(1, 'admin', 'bab4233796e57397abed34554e88cf27', 'goodtext.org', 'Email@goodtext.org', '', '218.8.204.239', '2014-12-16 16:54:44', '218.8.204.176', 339, 'http://goodtext.org/', 1, ''),
(2, 'goodtext', 'bab4233796e57397abed34554e88cf27', 'goodtext.org', 'as@goodtext.org', '2014-11-28 07:45:31', '218.8.205.239', '2014-11-29 16:35:33', '122.157.39.88', 20, 'goodtext.org', 1, '0');

-- --------------------------------------------------------

--
-- 表的结构 `g_info`
--

CREATE TABLE IF NOT EXISTS `g_info` (
  `g_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `g_name` varchar(100) NOT NULL,
  `g_text` varchar(3000) NOT NULL,
  `g_type` int(1) NOT NULL,
  PRIMARY KEY (`g_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;

--
-- 转存表中的数据 `g_info`
--

INSERT INTO `g_info` (`g_id`, `g_name`, `g_text`, `g_type`) VALUES
(1, '统计代码', '这里写入统计代码', 0),
(2, '首页轮播代码', '<div class=view-hover channelid="tzejudefaultpage" > <div id=pwSlidePlayer class=pwSlide> <div id=SlayerA_1 class=switchfilter> <span style="DISPLAY: none" class=switchItem> <A href="http://5.su.bdimg.com/skin/251.jpg" target=_blank><IMG src="http://5.su.bdimg.com/skin/251.jpg"><H3>极简风太单调？</H3></A> </span> <span style="DISPLAY: none" class=switchItem> <A href="#" target=_blank><IMG src="http://c.hiphotos.baidu.com/news/pic/item/dcc451da81cb39db1ea87d10d3160924ab18300f.jpg"><H3>领子越大越显瘦</H3></A> </span> <span style="DISPLAY: none" class=switchItem> <A href="http://b.hiphotos.baidu.com/news/pic/item/377adab44aed2e73545c9d6a8401a18b87d6fa3b.jpg" target=_blank><IMG src="http://b.hiphotos.baidu.com/news/pic/item/377adab44aed2e73545c9d6a8401a18b87d6fa3b.jpg"><H3>科技界最先进的九大植入式技术</H3></A> </span> <span style="DISPLAY: none" class=switchItem> <A href="http://www.goodtext.org" target=_blank><IMG src="http://img.gmw.cn/imgnews/attachement/jpg/site2/20141201/bc305bbef1b215e62b4107.jpg"><H3>3e4eweew</H3></A> </span> </div> <div class=pwSlide-bg></div> <div id=SlayerA_2 class=SwitchNav> <span class=navpad> </span> <span class=switchNavItem><A href="javascript:;">1</A> </span> <span class=switchNavItem><A href="javascript:;">2</A> </span> <span class=switchNavItem><A href="javascript:;">3</A> </span> <span class=switchNavItem><A href="javascript:;">4</A> </span> </div></div></div> <SCRIPT>ddSliderPlayers("SlayerA_1","SlayerA_2",5,"current");</SCRIPT>', 0),
(3, '首页TAG', '<p class="p1"> <a href="/index.php?c=index&a=tags&tag=好文本网" target="_blank">好文本网</a> <a href="/index.php?c=index&a=tags&tag=GTCMS" target="_blank">GTCMS</a> <a href="/index.php?c=index&a=tags&tag=好文本网" target="_blank">好文本网</a> </p>', 0);

-- --------------------------------------------------------

--
-- 表的结构 `g_article`
--

CREATE TABLE IF NOT EXISTS `g_article` (
  `g_id` int(11) NOT NULL AUTO_INCREMENT,
  `g_cid` int(11) DEFAULT NULL,
  `g_title` varchar(255) DEFAULT NULL,
  `g_tag` varchar(255) DEFAULT NULL,
  `g_des` varchar(1000) DEFAULT NULL,
  `g_content` text,
  `g_author` varchar(100) DEFAULT NULL,
  `g_imgurl` varchar(128) DEFAULT NULL,
  `g_time` varchar(20) DEFAULT NULL,
  `g_top` tinyint(1) DEFAULT '0',
  `g_rec` tinyint(1) DEFAULT '0',
  `g_click` int(11) DEFAULT '0',
  PRIMARY KEY (`g_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=12 ;

--
-- 转存表中的数据 `g_article`
--

INSERT INTO `g_article` (`g_id`, `g_cid`, `g_title`, `g_tag`, `g_des`, `g_content`, `g_author`, `g_imgurl`, `g_time`, `g_top`, `g_rec`, `g_click`) VALUES
(1, 1, 'GTCMS好文本网站内容管理系统', 'GTCMS,好文本网', '《GTCMS好文本网站内容管理系统》（简称GTCMS）是由好文本网采用PHP5+MYSQL做为技术基础进行开发。GTCMS采用GTPHP（MVC框架）为基础运行框架搭建。框架易于功能扩展，代码简单，可满足网站的应用需求。\r\n\r\n好文本网创建于07年，长期从事专业的网站内管理系统的开发与建设，经过长期研究与实践，成功开发出多套网站应用系统。好文本网始终秉承简单、易用、轻巧、快速的理念,为广大站长提供操作简单,部署灵活,界面简洁的建站工具。', '《GTCMS好文本网站内容管理系统》<br />\r\n<br />\r\n开发：好文本网<br />\r\n<br />\r\n官网；http://goodtext.org/<br />\r\n<br />\r\n<br />\r\n《GTCMS好文本网站内容管理系统》（简称GTCMS）是由好文本网采用PHP5+MYSQL做为技术基础进行开发。GTCMS采用GTPHP（MVC框架）为基础运行框架搭建。框架易于功能扩展，代码简单，可满足网站的应用需求。<br />\r\n<br />\r\n好文本网创建于07年，长期从事专业的网站内管理系统的开发与建设，经过长期研究与实践，成功开发出多套网站应用系统。好文本网始终秉承简单、易用、轻巧、快速的理念,为广大站长提供操作简单,部署灵活,界面简洁的建站工具。<br />\r\n<br />\r\nGTCMS是由好文本网总结之前WEB开发经验，秉承简单、易用、轻巧、快速的理念开发出的一套优秀的网站内容管理系统。GTCMS可用于搭建各种网站，其中众多设计方便灵活，可满足各种特色企业网站的设计需求。<br />\r\n<br />\r\nGTCMS功能特点：<br />\r\n<br />\r\n1、采用MVC框架，以自行开发的GTPHP框架为基础，易于学习，方便扩展。<br />\r\n2、可以生成静态网页，利于优化和降低服务器负载。<br />\r\n3、模块化设计，包含文章、图片、视频、下载等常用模块。<br />\r\n4、多项SEO优化设计，sitemap生成、搜索引擎提交、归档链接、网站导航地图、TAG标签等众多优化项目，配合前端模板优化效果极佳。<br />\r\n5、后台多用户设计，可以添加多位管理员，为不同管理角色分配不同权限。<br />\r\n6、多项自由信息设置，为前端设计师提供更多自由。<br />\r\n7、插件接口，可方便增加插件和调用外部数据。<br />\r\n8、更自由的导航，可增加不同类型的导航菜单。<br />\r\n9、自由增加单页，可添加独立于网站的单页，并为单页设置不同的模板和关键词。<br />\r\n9、不同分类应用不同模板目录，为网站增添更多特色，破除了单一模板的限制。<br />\r\n<br />\r\n<br />\r\n基于PHP+MYSQL环境运行<br />\r\n<br />\r\n最低配置:<br />\r\nPHP 5以上和MySQL 5以上<br />\r\nPDO MySQL模块必须<br />\r\n多字节的支持/ mbstring必须启用<br />\r\n<br />\r\n推荐配置:<br />\r\nPHP 5.3和MySQL 5.5<br />\r\nPDO MySQL模块必须<br />\r\n多字节的支持/ mbstring必须启用<br />\r\n<div>\r\n	<br />\r\n</div>', 'goodtext.org', NULL, '1414194918', NULL, NULL, 38),
(2, 1, '安装GTCMS所需要的服务器环境', '安装,GTCMS,配置', 'GTCMS开发时服务器环境为:Linux + Apache2 + MySQL 5.1 + PHP 5.3 。\r\n推荐配置:\r\nPHP 5.3和MySQL 5.5\r\nPDO MySQL模块必须\r\n多字节的支持/ mbstring必须启用', '<h5 style="font-size:12px;vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	安装GTCMS所需要的服务器环境:\r\n</h5>\r\n<pre>基于PHP+MYSQL环境运行\r\n\r\n最低配置:\r\nPHP 5以上和MySQL 5以上\r\nPDO MySQL模块必须\r\n多字节的支持/ mbstring必须启用\r\n\r\n推荐配置:\r\nPHP 5.3和MySQL 5.5\r\nPDO MySQL模块必须\r\n多字节的支持/ mbstring必须启用\r\n</pre>\r\n<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	GTCMS开发时服务器环境为:Linux + Apache2 + MySQL 5.1 + PHP 5.3 。\r\n</p>\r\n<div>\r\n	<br />\r\n</div>', 'goodtext.org', NULL, '1417947731', NULL, NULL, 4),
(3, 1, '运行系统内的自动安装脚本安装GTCMS', '自动安装,GTCMS', '安装GTCMS。\r\n自动安装:\r\n\r\n通过运行系统内的自动安装脚本安装GTCMS。\r\n1.下载程序并解压\r\n2.将gtcms目录里的文件上传至站点根目录（不包括gtcms目录本身）。\r\n3.浏览器地址栏中打开http://你的域名/install.php,按照要求完成安装过程。', '<h4 class="gt-text-large" style="font-size:20px;vertical-align:baseline;font-weight:300;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	安装GTCMS。\r\n</h4>\r\n<hr />\r\n<h5 style="font-size:12px;vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	自动安装:\r\n</h5>\r\n<pre>通过运行系统内的自动安装脚本安装GTCMS。\r\n1.下载程序并解压\r\n2.将gtcms目录里的文件上传至站点根目录（不包括gtcms目录本身）。\r\n3.浏览器地址栏中打开http://你的域名/install.php,按照要求完成安装过程。\r\n</pre>\r\n<div>\r\n	<br />\r\n</div>', 'goodtext.org', NULL, '1417947906', NULL, NULL, 0),
(4, 1, '站点根目录手动安装GTCMS', '手动安装,GTCMS', '手动安装:\r\n\r\n1.下载程序并解压\r\n2.将gtcms目录里的文件上传至站点根目录（不包括gtcms目录本身）。\r\n3.将gtcms目录里的gtcms.sql导入数据库，可登陆PhpMyAdmin等数据库管理界面导入。\r\n4.修改站点根目录下Gsys目录中的Config.php配置文件，正确填写数据库名、数据库用户名等。\r\n5.浏览器地址栏中打开http://你的域名/index.php?c=login ，默认管理员:admin ，密码:goodtext.org', '<h5 style="font-size:12px;vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	手动安装:\r\n</h5>\r\n<pre>1.下载程序并解压\r\n2.将gtcms目录里的文件上传至站点根目录（不包括gtcms目录本身）。\r\n3.将gtcms目录里的gtcms.sql导入数据库，可登陆PhpMyAdmin等数据库管理界面导入。\r\n4.修改站点根目录下Gsys目录中的Config.php配置文件，正确填写数据库名、数据库用户名等。\r\n5.浏览器地址栏中打开http://你的域名/index.php?c=login ，默认管理员:admin ，密码:goodtext.org</pre>', 'goodtext.org', NULL, '1417948003', NULL, NULL, 0),
(5, 1, '网站目录中安装GTCMS的方法说明', '目录安装,GTCMS', '目录安装:\r\n如果不想在网站根目录安装GTCMS或者根目录已经有其他系统，可以选择在网站目录中安装。\r\n先下载程序并解压\r\n在上传文件到网站目录之前先修改gtcms\\Gsys目录中的Gsystem.php文件。', '<h5 style="font-size:12px;vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	目录安装:\r\n</h5>\r\n<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	如果不想在网站根目录安装GTCMS或者根目录已经有其他系统，可以选择在网站目录中安装。\r\n</p>\r\n<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	先下载程序并解压\r\n</p>\r\n<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	在上传文件到网站目录之前先修改gtcms\\Gsys目录中的Gsystem.php文件。\r\n</p>\r\n<span style="color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;line-height:normal;background-color:#FFFFFF;">Gsystem.php第18行：</span> \r\n<pre class=" language-css"><span class="token function">define</span>(<span class="token string">''__Gurl__''</span>, <span class="token string">''/''</span>)<span class="token punctuation">;</span> // 系统安装目录</pre>\r\n<span style="color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;line-height:normal;background-color:#FFFFFF;">例如将好文本网站内容管理系统安装在网站根目录下的gtcms目录中：</span> \r\n<pre class=" language-css"><span class="token function">define</span>(<span class="token string">''__Gurl__''</span>, <span class="token string">''/gtcms/''</span>)<span class="token punctuation">;</span> // 系统安装目录</pre>\r\n<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	修改以后再进行安装。自动安装执行http://你的域名/系统安装目录/install.php,按照要求完成安装过程。\r\n</p>', 'goodtext.org', NULL, '1417948100', NULL, NULL, 0),
(6, 1, 'GTCMS系统配置说明', 'GTCMS,系统配置', '系统配置:\r\n系统配置非常重要,如果配置错误系统无法正常使用,有些配置项目需要在开始使用时就设置好,之后一般不需改动。\r\n系统配置文件路径为系统目录中Gsys目录下的Config.php(Gsys\\Config.php)。\r\n自动安装系统时，会生成一个配置文件，安装好系统之后可以根据需要修改。', '系统配置:\r\n系统配置非常重要,如果配置错误系统无法正常使用,有些配置项目需要在开始使用时就设置好,之后一般不需改动。\r\n系统配置文件路径为系统目录中Gsys目录下的Config.php(Gsys\\Config.php)。\r\n自动安装系统时，会生成一个配置文件，安装好系统之后可以根据需要修改。\r\nConfig.php：\r\n<!--?php defined(''GTPHP_PATH'') || exit(''Access Denied''); // 系统基本配置 $Config[''UrlControllerName''] = ''c''; // 自定义控制器名称 例如: index.php?c=index $Config[''UrlActionName''] = ''a''; // 自定义方法名称 例如: index.php?c=index&a=IndexAction $Config[''Gdebug''] = ''false''; // 报告错误 true为报告错误 $Config[''Adminuser''] = ''admin''; // 超级管理员 // 插件设置 $Plugins_upimgurl = ''/Static/uploads/''; // 编辑器插件上传路径 class myconfig { public function myconfig() { $myconfig=array( ''Tohtml'' =-->  ''true'',    // 生成静态文件 true开启，false关闭.\r\n        ''Suffix'' =&gt; ''.htm'', // 伪静态后缀\r\n        ''DRurl'' =&gt; 2, // 伪静态URL 1关闭 2开启\r\n        ''Uploads'' =&gt; ''Static/'',\r\n        ''APagesize'' =&gt; ''10'',    // 每页文章数\r\n        ''PPagesize'' =&gt; ''8'',    // 每页图片数\r\n        ''VPagesize'' =&gt; ''4'',    // 每页视频数\r\n        ''DPagesize'' =&gt; ''6'',    // 每页下载数\r\n        ''Sitesatrt'' =&gt; ''2014-12''        // 建站日期\r\n        );\r\n        return $myconfig;\r\n    }\r\n    public function mydbconfig()\r\n    {\r\n        $dbconfig=array(\r\n            ''database_type'' =&gt; ''mysql'',\r\n            ''server'' =&gt;''localhost'', //数据库所在IP，如果是本地，默认localhost \r\n            ''database_name'' =&gt;''数据库名'', //数据库名\r\n            ''username'' =&gt;''数据库用户名'', //数据库用户名 \r\n            ''password'' =&gt;''数据库密码'', //数据库密码 \r\n            ''port'' =&gt;3306, //数据库端口号 \r\n            ''charset'' =&gt;''utf8'' //字符集\r\n            );\r\n        return $dbconfig;\r\n    }\r\n    //前端插件\r\n    public function myplugin()\r\n    {\r\n        $plugins=array(\r\n            ''plugin_1''=&gt; array(\r\n            ''plugin_on_off''=&gt;''true'', //插件开关\r\n            ''plugin_name''=&gt;''插件名称'', //插件名称\r\n            ''plugin_directory''=&gt;''TestHook'' //插件安装路径\r\n            ),\r\n            ''plugin_2''=&gt; array(\r\n            ''plugin_on_off''=&gt;''true'', //插件开关\r\n            ''plugin_name''=&gt;''插件名称'', //插件名称\r\n            ''plugin_directory''=&gt;''TestHook1'' //插件安装路径\r\n            )\r\n        );\r\n        return $plugins;\r\n    }\r\n}\r\n配置中有些是固定项目例如：\r\n$Config[''UrlControllerName''] = ''c'';         // 自定义控制器名称 例如: index.php?c=index\r\n$Config[''UrlActionName''] = ''a'';             // 自定义方法名称 例如: index.php?c=index&amp;a=IndexAction      \r\n这2项为GTPHP框架设置项，因为系统应用路径都以框架默认参数为基础判定，所以这2个项目不要修改。\r\n$Config[''Gdebug''] = ''false'';         // 报告错误 true为报告错误      \r\n上面是GTPHP框架报告错误设置，false为不输出错误信息，true为输出错误信息，一般调试好系统以后设为false即可。\r\n$Config[''Adminuser''] = ''admin'';         // 超级管理员\r\n此项设置是超级管理员，填入管理员用户名，此名管理员不受任何权限限制，拥有系统后台的全部权限。\r\n// 插件设置\r\n$Plugins_upimgurl = ''/Static/uploads/'';            // 编辑器插件上传路径\r\n此项设置是编辑文章所用的在线编辑器上传路径。\r\n''Tohtml'' =&gt;  ''true'',    // 生成静态文件 true开启，false关闭.\r\n''Suffix'' =&gt; ''.htm'', // 伪静态后缀\r\n''DRurl'' =&gt; 2, // 伪静态URL 1关闭 2开启\r\n''Tohtml'' =&gt; ''true'' 开启静态网页生成功能,''Tohtml'' =&gt; ''false'' 关闭静态网页生成功能。\r\n''Suffix'' =&gt; ''.htm'' 设置生成的静态网页文件的后缀名，只有开启上面静态生成功能此设置才有效。\r\nDRurl 设置伪静态URL 1关闭 2开启，如果不需要生成静态或者不使用伪静态就设置成关闭。 如果是伪静态此项设置为2，Tohtml设置为false，需要同时配合伪静态规则。\r\n''Uploads'' =&gt; ''Static/'',\r\n此项是后台图片上传目录设置.\r\n''APagesize'' =&gt; ''10'',    // 每页文章数\r\n''PPagesize'' =&gt; ''8'',    // 每页图片数\r\n''VPagesize'' =&gt; ''4'',    // 每页视频数\r\n''DPagesize'' =&gt; ''6'',    // 每页下载数\r\n此项是各模块前端分页数,可以根据前端设计需要进行修改.\r\n''server'' =&gt;''localhost'', //数据库所在IP，如果是本地，默认localhost \r\n''database_name'' =&gt;''数据库名'', //数据库名\r\n''username'' =&gt;''数据库用户名'', //数据库用户名 \r\n''password'' =&gt;''数据库密码'', //数据库密码 \r\n''port'' =&gt;3306, //数据库端口号 \r\n''charset'' =&gt;''utf8'' //字符集\r\n数据库链接设置.\r\n            //插件1\r\n            ''plugin_1''=&gt; array(\r\n            ''plugin_on_off''=&gt;''true'', //插件开关\r\n            ''plugin_name''=&gt;''插件名称'', //插件名称\r\n            ''plugin_directory''=&gt;''TestHook'' //插件安装路径\r\n            ),\r\n            //插件2\r\n            ''plugin_2''=&gt; array(\r\n            ''plugin_on_off''=&gt;''true'', //插件开关\r\n            ''plugin_name''=&gt;''插件名称'', //插件名称\r\n            ''plugin_directory''=&gt;''TestHook1'' //插件安装路径\r\n            )\r\n插件设置目前比较简单，插件机制还有待完善。这里2个插件示范，这2个插件是首页调用插件.\r\n现阶段系统只是引入插件文件并前端显示插件输出内容。例如示例插件TestHook文件位于\\Gsys\\Plugins\\目录中，以TestHook.php文件输出内容为前端显示内容。\r\n插件可以自由增加，但插件错误将影响系统，例如：插件运行效率低过多冗陈，将严重拖慢系统。应尽量保证插件质量和数量，不必要插件应该关闭或删除。\r\n插件开发请阅读 - 系统插件 部分的说明。', 'goodtext.org', NULL, '1417948219', NULL, 1, 0),
(7, 1, 'GTCMS系统参数设置', 'GTCMS,参数设置', 'GTCMS系统设置\r\nGTCMS设置分为系统参数设置、网站设置、权限设置等\r\n系统参数设置参考系统配置文件说明部分的内容。', '<h4 class="gt-text-large h4top" style="font-size:20px;vertical-align:baseline;font-weight:300;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	GTCMS系统设置。\r\n</h4>\r\n<h4 class="gt-text-large h4top" style="font-size:20px;vertical-align:baseline;font-weight:300;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	<span style="font-size:12px;line-height:1.5;">GTCMS设置分为系统参数设置、网站设置、权限设置等</span>\r\n</h4>\r\n<h5 style="font-size:12px;vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	<span style="line-height:1.5;font-weight:normal;">系统参数设置</span>\r\n</h5>\r\n<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	系统参数设置参考系统配置文件说明部分的内容。\r\n</p>\r\n<h5 style="font-size:12px;vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	网站设置\r\n</h5>\r\n<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	网站设置就是如网站名称、网站URL、关键字……等等。网站设置还包括网站导航、网站信息(如：联系方式、关于)、管理员权限等。\r\n</p>\r\n<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	以往一些网站内容管理系统诸如网站名称、网站URL、关键字、简介、备案号等都设置成固定项目，不仅无法改变用途也没办法增加和删除这些项目。有时候根据网站不同需求需要增加配置项目，GTCMS为用户提供了 配置项管理 。通过此项细节设计用户可以自由增加网站设置项目，并且能在前端模板中自由调用。\r\n</p>\r\n<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	系统配置项目可以自由增加\\删除\\修改.系统默认已经配置好一些项目——1 网站名称、 、2 网站关键字、3 网站简介、4 网站URL、5 百度数据推送接口，这些系统必要配置项目不要删除。\r\n</p>', 'goodtext.org', NULL, '1417948649', NULL, NULL, 0),
(8, 1, 'GTCMS系统自定义信息设置', 'GTCMS,参数设置', '自定义信息设置\r\n\r\n自定义信息是自定义配置的扩展，除了灵活性相同外，自定义信息可自定义网站的大块代码，比如广告代码、社会化评论代码，统计代码等等。配置只能写入简单文本，自定义信息可以写入更长内容。想怎么用都可以，修改起来也方便。', '自定义信息设置\r\n\r\n自定义信息是自定义配置的扩展，除了灵活性相同外，自定义信息可自定义网站的大块代码，比如广告代码、社会化评论代码，统计代码等等。配置只能写入简单文本，自定义信息可以写入更长内容。想怎么用都可以，修改起来也方便。', 'goodtext.org', NULL, '1417948811', NULL, NULL, 0),
(9, 1, 'GTCMS系统导航栏设置', 'GTCMS,导航栏设置', '网站中导航栏很重要。清晰的网站导航能帮助访客找到他们需要的信息，最常见的，全局导航、局部导航和辅助导航等。GTCMS可以自定义导航栏种类，导航可设置URL、URL名称、排序、隐藏几项。导航栏可以在所有前端模板页中随意调用。应用此项设置设置顶部导航、底部导航、主导航栏...等等。', '<h5 style="font-size:12px;vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	导航栏设置\r\n</h5>\r\n<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	网站中导航栏很重要。清晰的网站导航能帮助访客找到他们需要的信息，最常见的，全局导航、局部导航和辅助导航等。GTCMS可以自定义导航栏种类，导航可设置URL、URL名称、排序、隐藏几项。导航栏可以在所有前端模板页中随意调用。应用此项设置设置顶部导航、底部导航、主导航栏...等等。\r\n</p>\r\n<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	自定义配置、自定义信息、导航栏都可以在所有前端模板页中随意调用\r\n</p>', 'goodtext.org', NULL, '1417948932', NULL, NULL, 0),
(10, 1, 'GTCMS系统后台权限设置', 'GTCMS,权限设置', '网站后台权限设置-后台用户管理，只针对管理员，前端访问与此无关。比如网站需要编辑，编辑不需要修改网站设置或访问后台其他页面，站长只要分配最少的权限给这些不同的管理员即可。\r\n管理员分九个等级（一级~九级），九级是最高等级。权限管理可以为后台页面设置访问等级，例如一个后台管理页面设置成五级，要进入这个页面最少需要是五级管理权限的管理员才行。', '<h5 style="font-size:12px;vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	<h5 style="font-size:12px;vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n		后台权限设置\r\n	</h5>\r\n	<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n		网站后台权限设置-后台用户管理，只针对管理员，前端访问与此无关。比如网站需要编辑，编辑不需要修改网站设置或访问后台其他页面，站长只要分配最少的权限给这些不同的管理员即可。\r\n	</p>\r\n	<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n		管理员分九个等级（一级~九级），九级是最高等级。权限管理可以为后台页面设置访问等级，例如一个后台管理页面设置成五级，要进入这个页面最少需要是五级管理权限的管理员才行。\r\n	</p>\r\n	<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n		后台权限设置在没有设置页面等级的时候,全部默认为禁止访问状态,超级管理员不受限制. 可以以超级管理员帐户登陆后台,登陆后在 权限管理 (/index.php?c=config&amp;a=sysnode)页面设置页面访问等级。\r\n	</p>\r\n	<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n		设置页面访问等级只需要填写2项参数，即页面名称和等级。名称不是随便填写的，而是根据页面URL名来确定。 比如后台首页访问URL地址http://你的域名/index.php?c=admin&amp;a=index，那么权限管理中的 名称 项就填写admin_index，然后设置访问等级，这样该等级以上的管理员就能访问这个页面了。\r\n	</p>\r\n	<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n		GTCMS的权限管理简单高效，不过可能无法满足复杂需求，之后会根据需要改进。\r\n	</p>\r\n</h5>\r\n<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	<br />\r\n</p>', 'goodtext.org', NULL, '1417948986', NULL, NULL, 2),
(11, 1, 'GTCMS内容添加管理文章模块', 'GTCMS,好文本网', '文章模块\r\n\r\nGTCMS文章模块初始添加文章前需要先建立相关分类，然后再选择分类添加文章内容。\r\n在未添加分类和文章内容时前端访问会出现错误代码或空白，这是调用内容不存在造成的，添加内容或修改模板后就会正常。', '<h5 style="font-size:12px;vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	GTCMS内容添加管理\r\n</h5>\r\n<hr />\r\n<h5 style="font-size:12px;vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	文章模块\r\n</h5>\r\n<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	GTCMS文章模块初始添加文章前需要先建立相关分类，然后再选择分类添加文章内容。\r\n</p>\r\n<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	在未添加分类和文章内容时前端访问会出现错误代码或空白，这是调用内容不存在造成的，添加内容或修改模板后就会正常。\r\n</p>\r\n<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	增加文章分类表单有２项可填写－－分类名称、模板目录，模板目录用于设置该分类应用的模板所在的目录（每一个分类都可以使用不同的模板），模板目录可以为空，为空时默认使用系统模板（模板目录详见本手册　模板说明　部分）。\r\n</p>\r\n<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	文章管理：日常添加、删除、修改文章的操作。添加文章，左侧菜单进入文章管理页面 ==&gt; 添加一条新记录,进入添加文章的表单页，先选择分类 ，标题、标签、简介、内容等依次填写。图片:封面图片可选择本地图片（支持格式：jpg .jpeg .png .gif） 进行上传（上传的图片自动保存源图和缩略图，源图和缩略图可在模板中调用，调用方法详见本手册　模板说明　部分）。置顶和推荐可设置，时间:是系统时间戳，也可以手动填写时间戳。作者:默认是登陆的管理员，可修改。点击:文章阅读次数，默认即可。\r\n</p>\r\n<p style="vertical-align:baseline;color:#363533;font-family:宋体, ''Arial Narrow'', HELVETICA;background-color:#FFFFFF;">\r\n	编辑完文章点击添加按钮提交即可，如果系统开启了静态生成功能就会跳转生成页面来生成需要的静态页面。如果同时开启了搜索引擎动态提交，会看到　‘２００’　提交成功的反馈。如果没有开启静态生成功能会返回到文章管理列表。\r\n</p>', 'goodtext.org', NULL, '1417949292', NULL, NULL, 4);

-- --------------------------------------------------------

--
-- 表的结构 `g_calllist`
--

CREATE TABLE IF NOT EXISTS `g_calllist` (
  `g_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `g_xcid` varchar(20) NOT NULL,
  `g_tf` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`g_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- 表的结构 `g_child_downs`
--

CREATE TABLE IF NOT EXISTS `g_child_downs` (
  `g_pid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `g_id` int(11) unsigned DEFAULT NULL,
  `g_dname` varchar(300) DEFAULT NULL,
  `g_durl` varchar(300) DEFAULT NULL,
  PRIMARY KEY (`g_pid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;

--
-- 转存表中的数据 `g_child_downs`
--

INSERT INTO `g_child_downs` (`g_pid`, `g_id`, `g_dname`, `g_durl`) VALUES
(1, 1, '天空下载', 'http://www.skycn.com/?m=downloader&id=690'),
(2, 1, '官方下载', 'http://www.skycn.com/soft/appid/690.html');

-- --------------------------------------------------------

--
-- 表的结构 `g_child_pics`
--

CREATE TABLE IF NOT EXISTS `g_child_pics` (
  `g_pid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `g_id` int(11) unsigned DEFAULT NULL,
  `g_pname` varchar(300) DEFAULT NULL,
  `g_photo` varchar(300) DEFAULT NULL,
  PRIMARY KEY (`g_pid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- 转存表中的数据 `g_child_pics`
--

INSERT INTO `g_child_pics` (`g_pid`, `g_id`, `g_pname`, `g_photo`) VALUES
(1, 1, '图片集', '02.jpg');

-- --------------------------------------------------------

--
-- 表的结构 `g_class`
--

CREATE TABLE IF NOT EXISTS `g_class` (
  `g_cid` int(11) NOT NULL AUTO_INCREMENT,
  `g_name` varchar(255) DEFAULT NULL,
  `g_t` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`g_cid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- 转存表中的数据 `g_class`
--

INSERT INTO `g_class` (`g_cid`, `g_name`, `g_t`) VALUES
(1, '测试', NULL);

-- --------------------------------------------------------

--
-- 表的结构 `g_dclass`
--

CREATE TABLE IF NOT EXISTS `g_dclass` (
  `g_cid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `g_name` varchar(255) NOT NULL,
  `g_t` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`g_cid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- 转存表中的数据 `g_dclass`
--

INSERT INTO `g_dclass` (`g_cid`, `g_name`, `g_t`) VALUES
(1, '下载分类', NULL);

-- --------------------------------------------------------

--
-- 表的结构 `g_down`
--

CREATE TABLE IF NOT EXISTS `g_down` (
  `g_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `g_cid` int(11) NOT NULL,
  `g_title` varchar(300) NOT NULL,
  `g_key` varchar(300) DEFAULT NULL,
  `g_des` varchar(3000) DEFAULT NULL,
  `g_pic` varchar(300) DEFAULT NULL,
  `g_info1` varchar(50) DEFAULT NULL,
  `g_info2` varchar(50) DEFAULT NULL,
  `g_info3` varchar(50) DEFAULT NULL,
  `g_info4` varchar(50) DEFAULT NULL,
  `g_info5` varchar(50) DEFAULT NULL,
  `g_info6` varchar(50) DEFAULT NULL,
  `g_info7` varchar(50) DEFAULT NULL,
  `g_info8` varchar(50) DEFAULT NULL,
  `g_info9` varchar(50) DEFAULT NULL,
  `g_info10` varchar(50) DEFAULT NULL,
  `g_content` text,
  `g_click` int(11) DEFAULT '0',
  `g_time` varchar(30) DEFAULT NULL,
  `g_top` tinyint(1) DEFAULT NULL,
  `g_rec` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`g_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- 转存表中的数据 `g_down`
--

INSERT INTO `g_down` (`g_id`, `g_cid`, `g_title`, `g_key`, `g_des`, `g_pic`, `g_info1`, `g_info2`, `g_info3`, `g_info4`, `g_info5`, `g_info6`, `g_info7`, `g_info8`, `g_info9`, `g_info10`, `g_content`, `g_click`, `g_time`, `g_top`, `g_rec`) VALUES
(1, 1, 'QQ2014|QQ6.7', 'qq2014下载，qq2014官方下载', 'QQ2014QQ6.7最新版官方下载，QQ闪登、封面主题、动态天气、个性的资料展示，全新的界面和功能设计让你领略一个不一样的qq2014QQ6.7。崭新的体验，让我们开始启程！', 'cezmxy4tcy81g.png', '大小：56.36 MB', '语言：简体中文', '类型：免费软件', '更新日期：2014-12-15', '插件情况：绿色', '推荐评级：五星', '适合系统：Win7/WinXP/Win8', '相关链接：Home Page', '演示地址：Demo Url', '软件授权: 免费版', '<span class="til" style="font-weight:bold;line-height:22px;font-family:tahoma, Arial, 宋体, 微软雅黑;background-color:#FFFFFF;"> \r\n<h2 style="font-size:12px;">\r\n	QQ2014|QQ6.7官网简介：\r\n</h2>\r\n</span> \r\n<p id="j_soft_desc" style="font-family:tahoma, Arial, 宋体, 微软雅黑;background-color:#FFFFFF;">\r\n	<span class="short-desc"><b>QQ2014</b><b>QQ6.7</b>最新版官方下载，QQ闪登、封面主题、动态天气、个性的资料展示，全新的界面和功能设计让你领略一个不一样的<b>qq2014</b><b>QQ6.7</b>。崭新的体验，让我们开始启程！</span> \r\n</p>', 0, '1418690295', NULL, NULL);

-- --------------------------------------------------------

--
-- 表的结构 `g_pages`
--

CREATE TABLE IF NOT EXISTS `g_pages` (
  `g_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `g_title` varchar(300) NOT NULL,
  `g_key` varchar(300) NOT NULL,
  `g_des` varchar(500) NOT NULL,
  `g_content` text NOT NULL,
  `g_t` varchar(128) DEFAULT NULL,
  `g_oname` varchar(128) DEFAULT NULL,
  `g_click` int(11) DEFAULT '0',
  PRIMARY KEY (`g_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- 转存表中的数据 `g_pages`
--

INSERT INTO `g_pages` (`g_id`, `g_title`, `g_key`, `g_des`, `g_content`, `g_t`, `g_oname`, `g_click`) VALUES
(1, '关于我们', '关于我们,about_us', '关于我们|about_us', '好文本网\r\n简单、易用、轻巧、快速的网站内容管理工具。', NULL, NULL, 0);

-- --------------------------------------------------------

--
-- 表的结构 `g_pclass`
--

CREATE TABLE IF NOT EXISTS `g_pclass` (
  `g_cid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `g_name` varchar(255) NOT NULL,
  `g_t` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`g_cid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- 转存表中的数据 `g_pclass`
--

INSERT INTO `g_pclass` (`g_cid`, `g_name`, `g_t`) VALUES
(1, '图片集', NULL);

-- --------------------------------------------------------

--
-- 表的结构 `g_pic`
--

CREATE TABLE IF NOT EXISTS `g_pic` (
  `g_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `g_cid` int(11) NOT NULL,
  `g_title` varchar(300) NOT NULL,
  `g_key` varchar(300) DEFAULT NULL,
  `g_des` varchar(3000) DEFAULT NULL,
  `g_pic` varchar(300) NOT NULL,
  `g_time` varchar(30) DEFAULT NULL,
  `g_top` tinyint(1) DEFAULT NULL,
  `g_rec` tinyint(1) DEFAULT NULL,
  `g_click` int(11) DEFAULT '0',
  PRIMARY KEY (`g_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

--
-- 转存表中的数据 `g_pic`
--

INSERT INTO `g_pic` (`g_id`, `g_cid`, `g_title`, `g_key`, `g_des`, `g_pic`, `g_time`, `g_top`, `g_rec`, `g_click`) VALUES
(1, 1, '图片集', '图片集', '图片集', '01.jpg', '1417479451', NULL, NULL, 0);

-- --------------------------------------------------------

--
-- 表的结构 `g_vclass`
--

CREATE TABLE IF NOT EXISTS `g_vclass` (
  `g_cid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `g_name` varchar(255) NOT NULL,
  `g_t` varchar(32) DEFAULT NULL,
  UNIQUE KEY `g_cid` (`g_cid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;

--
-- 转存表中的数据 `g_vclass`
--

INSERT INTO `g_vclass` (`g_cid`, `g_name`, `g_t`) VALUES
(1, '视频分类', NULL),
(2, '我的视频', NULL);

-- --------------------------------------------------------

--
-- 表的结构 `g_video`
--

CREATE TABLE IF NOT EXISTS `g_video` (
  `g_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `g_cid` int(11) NOT NULL,
  `g_title` varchar(300) NOT NULL,
  `g_key` varchar(300) DEFAULT NULL,
  `g_des` varchar(3000) DEFAULT NULL,
  `g_pic` varchar(300) DEFAULT NULL,
  `g_video_html` varchar(3000) DEFAULT NULL,
  `g_video_url` varchar(128) DEFAULT NULL,
  `g_video` varchar(128) DEFAULT NULL,
  `g_click` int(11) DEFAULT '0',
  `g_time` varchar(30) DEFAULT NULL,
  `g_top` tinyint(1) DEFAULT NULL,
  `g_rec` tinyint(1) DEFAULT NULL,
  UNIQUE KEY `g_id` (`g_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;

--
-- 转存表中的数据 `g_video`
--

INSERT INTO `g_video` (`g_id`, `g_cid`, `g_title`, `g_key`, `g_des`, `g_pic`, `g_video_html`, `g_video_url`, `g_video`, `g_click`, `g_time`, `g_top`, `g_rec`) VALUES
(1, 1, '《神雕侠侣》国色天香十大女配艳压小龙女', '娱乐,八卦,盘点,搞笑,吐槽', '视频介绍：由于金庸小说观众最喜欢，所以他的作品翻拍频率最高，几乎每部小说隔三差五就被搬出来', '2b49_bf0d1ce0_ac4f_6f9c_48d8_1f51d246e5d7_1.jpg', '<object width=500 height=408><param name="movie" value="http://share.vrs.sohu.com/my/v.swf&topBar=1&id=76800640&autoplay=false&from=page"></param><param name="allowFullScreen" value="true"></param><param name="allowscriptaccess" value="always"></param><param name="wmode" value="Transparent"></param><embed width=500 height=408 wmode="Transparent" allowfullscreen="true" allowscriptaccess="always" quality="high" src="http://share.vrs.sohu.com/my/v.swf&topBar=1&id=76800640&autoplay=false&from=page" type="application/x-shockwave-flash"/></embed></object>', NULL, NULL, 0, '1417949613', NULL, NULL),
(2, 1, 'nvidia 发布“全球首款移动超级计算机”', 'nvidia', 'nvidia 发布“全球首款移动超级计算机” 。', 'v_108664013_m_601_116_65.jpg', '<embed src="http://player.video.qiyi.com/8f1d820ad82634e49a3741fc10e7f09d/0/0/v_19rrn3rjto.swf-albumId=322489200-tvId=322489200-isPurchase=0-cnId=30" allowFullScreen="true" quality="high" width="480" height="350" align="middle" allowScriptAccess="always" type="application/x-shockwave-flash"></embed>', NULL, NULL, 0, '1417950068', NULL, NULL);

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
